from django_filters.rest_framework import (
    BaseInFilter,
    BooleanFilter,
    FilterSet,
)

from greg.models import (
    Person,
    PersonRole,
    PersonIdentity,
)


class PersonRoleFilter(FilterSet):
    type = BaseInFilter(field_name="role__type", lookup_expr="in")

    class Meta:
        model = PersonRole
        fields = ["type"]


class PersonFilter(FilterSet):
    verified = BooleanFilter(
        field_name="identities__verified_by_id", lookup_expr="isnull", exclude=True
    )

    class Meta:
        model = Person
        fields = ["first_name", "last_name", "verified"]


class PersonIdentityFilter(FilterSet):
    class Meta:
        model = PersonIdentity
        fields = ["type", "verified_by_id"]
