# Generated by Django 3.2.5 on 2021-08-23 08:53

import datetime
import dirtyfields.dirtyfields
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Consent',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('type', models.SlugField(max_length=64, unique=True)),
                ('consent_name_en', models.CharField(max_length=256)),
                ('consent_name_nb', models.CharField(max_length=256)),
                ('consent_description_en', models.TextField()),
                ('consent_description_nb', models.TextField()),
                ('consent_link_en', models.URLField(null=True)),
                ('consent_link_nb', models.URLField(null=True)),
                ('valid_from', models.DateField(default=datetime.date.today)),
                ('user_allowed_to_change', models.BooleanField()),
            ],
            options={
                'abstract': False,
            },
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='Notification',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('identifier', models.IntegerField(blank=True, null=True)),
                ('object_type', models.TextField()),
                ('operation', models.TextField()),
                ('issued_at', models.IntegerField()),
                ('meta', models.JSONField(blank=True, null=True)),
            ],
            options={
                'abstract': False,
            },
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='OrganizationalUnit',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('orgreg_id', models.CharField(max_length=256)),
                ('name_nb', models.CharField(max_length=256)),
                ('name_en', models.CharField(max_length=256)),
                ('parent', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='greg.organizationalunit')),
            ],
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='Person',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('first_name', models.CharField(max_length=256)),
                ('last_name', models.CharField(max_length=256)),
                ('date_of_birth', models.DateField(null=True)),
                ('email', models.EmailField(blank=True, max_length=254)),
                ('email_verified_date', models.DateField(null=True)),
                ('mobile_phone', models.CharField(blank=True, max_length=15)),
                ('mobile_phone_verified_date', models.DateField(null=True)),
                ('registration_completed_date', models.DateField(null=True)),
                ('token', models.CharField(blank=True, max_length=32)),
            ],
            options={
                'abstract': False,
            },
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='Role',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('type', models.SlugField(max_length=64, unique=True)),
                ('name_nb', models.CharField(max_length=256)),
                ('name_en', models.CharField(max_length=256)),
                ('description_nb', models.TextField()),
                ('description_en', models.TextField()),
                ('default_duration_days', models.IntegerField(null=True)),
            ],
            options={
                'abstract': False,
            },
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='ScheduleTask',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=32)),
                ('last_completed', models.DateTimeField(null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Sponsor',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('feide_id', models.CharField(max_length=256)),
                ('first_name', models.CharField(max_length=256)),
                ('last_name', models.CharField(max_length=256)),
            ],
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='SponsorOrganizationalUnit',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('hierarchical_access', models.BooleanField()),
                ('organizational_unit', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='link_unit', to='greg.organizationalunit')),
                ('sponsor', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='link_sponsor', to='greg.sponsor')),
            ],
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.AddField(
            model_name='sponsor',
            name='units',
            field=models.ManyToManyField(related_name='sponsor_unit', through='greg.SponsorOrganizationalUnit', to='greg.OrganizationalUnit'),
        ),
        migrations.CreateModel(
            name='PersonRole',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('start_date', models.DateField(null=True)),
                ('end_date', models.DateField()),
                ('contact_person_unit', models.TextField(blank=True)),
                ('comments', models.TextField(blank=True)),
                ('available_in_search', models.BooleanField(default=False)),
                ('person', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='person_roles', to='greg.person')),
                ('registered_by', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='sponsor_role', to='greg.sponsor')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='person_roles', to='greg.role')),
                ('unit', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='unit_person_role', to='greg.organizationalunit')),
            ],
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='PersonIdentity',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('type', models.CharField(choices=[('ID_PORTEN', 'Id Porten'), ('FEIDE_ID', 'Feide Id'), ('PASSPORT', 'Passport'), ('DRIVERS_LICENSE', 'Drivers License'), ('NATIONAL_ID_CARD', 'National Id Card'), ('NATIONAL_ID_NUMBER', 'National Id Number'), ('OTHER', 'Other')], max_length=18)),
                ('source', models.CharField(max_length=256)),
                ('value', models.CharField(max_length=256)),
                ('verified', models.CharField(blank=True, choices=[('AUTOMATIC', 'Automatic'), ('MANUAL', 'Manual')], max_length=9)),
                ('verified_when', models.DateField(null=True)),
                ('person', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='identities', to='greg.person')),
                ('verified_by', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='sponsor', to='greg.sponsor')),
            ],
            options={
                'abstract': False,
            },
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='PersonConsent',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('consent_given_at', models.DateField(null=True)),
                ('consent', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='link_person_consent', to='greg.consent')),
                ('person', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='link_person_consent', to='greg.person')),
            ],
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.AddField(
            model_name='person',
            name='consents',
            field=models.ManyToManyField(related_name='consent', through='greg.PersonConsent', to='greg.Consent'),
        ),
        migrations.AddField(
            model_name='person',
            name='roles',
            field=models.ManyToManyField(related_name='persons', through='greg.PersonRole', to='greg.Role'),
        ),
        migrations.AddConstraint(
            model_name='sponsororganizationalunit',
            constraint=models.UniqueConstraint(fields=('sponsor', 'organizational_unit'), name='sponsor_organizational_unit_unique'),
        ),
        migrations.AddConstraint(
            model_name='sponsor',
            constraint=models.UniqueConstraint(fields=('feide_id',), name='unique_feide_id'),
        ),
        migrations.AddConstraint(
            model_name='personrole',
            constraint=models.UniqueConstraint(fields=('person_id', 'role_id', 'unit_id', 'start_date', 'end_date'), name='person_role_unique'),
        ),
        migrations.AddConstraint(
            model_name='personconsent',
            constraint=models.UniqueConstraint(fields=('person', 'consent'), name='person_consent_unique'),
        ),
        migrations.AddConstraint(
            model_name='organizationalunit',
            constraint=models.UniqueConstraint(fields=('orgreg_id',), name='unique_orgreg_id'),
        ),
    ]
