import pytest
from rest_framework import status
from rest_framework.reverse import reverse

from greg.models import Consent


@pytest.fixture
def consent_foo() -> Consent:
    return Consent.objects.create(
        type="test_consent",
        consent_name_en="Test1",
        consent_name_nb="Test2",
        consent_description_en="Test description",
        consent_description_nb="Test beskrivelse",
        consent_link_en="https://example.org",
        consent_link_nb="https://example.org",
        valid_from="2018-01-20",
        user_allowed_to_change=True,
    )


@pytest.mark.django_db
def test_get_consent(client, consent_foo):
    resp = client.get(reverse("v1:consent-detail", kwargs={"id": consent_foo.id}))
    assert resp.status_code == status.HTTP_200_OK
    data = resp.json()
    assert data.get("id") == consent_foo.id
    assert data.get("type") == consent_foo.type
    assert data.get("consent_name_en") == consent_foo.consent_name_en
